import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Properties;

import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


public class CustFix1 extends HttpServlet implements Servlet {
	/* (non-Java-doc)
	 * @see javax.servlet.http.HttpServlet#HttpServlet()
	 */
	
    private String framework = "embedded";
    private String driver = "org.apache.derby.jdbc.EmbeddedDriver";
    private String protocol = "jdbc:derby:";

	public CustFix1() {
		super();
	}

	/* (non-Java-doc)
	 * @see javax.servlet.http.HttpServlet#doGet(HttpServletRequest arg0, HttpServletResponse arg1)
	 */
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
	    PrintWriter out = response.getWriter();
	    // response.setContentType("text/html");

		out.println("<HTML><BODY>");
		out.println("<TITLE>OWASP Demo SQL Injection</TITLE>");
		out.println("<H1>OWASP Demo</H1>");
		out.println("<H2>Customer Self Service</H2>");
		out.println("<H3>JDBC Bind Account fix</H3>");
	    out.println("<FORM NAME='customer' METHOD='POST' ACTION='CustFix1'>");
	    out.println("<br><br>Customer id: ");
	    out.println("<INPUT NAME='custid' size=50>");
	    out.println("  ");
	    out.println("<INPUT TYPE='SUBMIT' VALUE='GO!'>");
	    out.println("</FORM>");
	    out.println("</BODY></HTML>");
	}

	/* (non-Java-doc)
	 * @see javax.servlet.http.HttpServlet#doPost(HttpServletRequest arg0, HttpServletResponse arg1)
	 */
    public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    	String custid = null;
	    int i = 0;
	    PrintWriter out = response.getWriter();

	    custid = request.getParameter("custid");
    	ArrayList customers = new ArrayList();
	    getCustomers(custid, customers);
	    i = customers.size();

		out.println("<HTML><BODY>");
		out.println("<TITLE>OWASP Demo SQL Injection</TITLE>");
		out.println("<H1>OWASP Demo</H1>");
		out.println("<H2>Customer Self Service</H2>");
		out.println("<H3>JDBC Bind Account fix</H3>");
	    out.println("</BODY></HTML>");
	    out.println("<TABLE BORDER='2'>");
	    
	    for (i=0; i<customers.size(); i++) {
	    	if (i % 6 == 0) {
	    		if (i != 0 ) {
	    			out.println("</TR>");
	    		}
	    		out.println("<TR>");
	    	}
	    	out.println("<TD>");
	    	out.println(customers.get(i));
	    	out.println("</TD>");
	    }
	    out.println("</TR>");
	    out.println("</TABLE>");
	    out.println("</BODY></HTML>");
    }

    private void getCustomers(String userid, ArrayList customers) {
        loadDriver();
        Connection conn = null;
        ArrayList statements = new ArrayList(); // list of Statements, PreparedStatements
        Statement s = null;
        ResultSet rs = null;
        String query = null;
        
        try {
        	Properties props = new Properties(); // connection properties
        	getProperties (props);
        	String dbName = "db/CODB"; // the name of the database
        	conn = DriverManager.getConnection(protocol + dbName, props);
        	
            // We want to control transactions manually. Autocommit is on by
            // default in JDBC.
            conn.setAutoCommit(false);

            /* Creating a statement object that we can use for running various
             * SQL statements commands against the database.*/
            s = conn.createStatement();
            s.execute("SET SCHEMA CODB");
        	
            /*
            We select the rows and verify the results.
            */
            customers.add("Row Id");
            customers.add("User Id");
            customers.add("First Name");
            customers.add("Last Name");
            customers.add("SSN");
            customers.add("DOB");
           
            query = "SELECT * FROM CUSTOMER WHERE USERID = '";
            query = query + userid.toUpperCase() + "'";
            rs = s.executeQuery(query);

            while (rs.next()) {
            	customers.add(String.valueOf(rs.getInt("ID")));
            	customers.add(rs.getString("USERID"));
            	customers.add(rs.getString("FNAME"));
            	customers.add(rs.getString("LNAME"));
            	customers.add(rs.getString("SSN"));
            	customers.add(String.valueOf(rs.getDate("DOB")));
            }
        	rs.close();
        	
        	try {
        		DriverManager.getConnection(protocol + ";shutdown=true");
        	}
            catch (SQLException se) {
                if (( (se.getErrorCode() == 50000)
                        && ("XJ015".equals(se.getSQLState()) ))) {
                    // we got the expected exception
                    System.out.println("Derby shut down normally");
                    // Note that for single database shutdown, the expected
                    // SQL state is "08006", and the error code is 45000.
                } else {
                    // if the error code or SQLState is different, we have
                    // an unexpected exception (shutdown failed)
                    System.err.println("Derby did not shut down normally");
                    printSQLException(se);
                }
            }
        }

        catch (SQLException sqle) {
        	printSQLException(sqle);
	    }
        finally {
        	System.err.println("Derby did not shut down normally");
        }
    }
    
    private void loadDriver() {
        /*
         *  The JDBC driver is loaded by loading its class.
         *  If you are using JDBC 4.0 (Java SE 6) or newer, JDBC drivers may
         *  be automatically loaded, making this code optional.
         *
         *  In an embedded environment, this will also start up the Derby
         *  engine (though not any databases), since it is not already
         *  running. In a client environment, the Derby engine is being run
         *  by the network server framework.
         *
         *  In an embedded environment, any static Derby system properties
         *  must be set before loading the driver to take effect.
         */
        try {
            Class.forName(driver).newInstance();
            System.out.println("Loaded the appropriate driver");
        } catch (ClassNotFoundException cnfe) {
            System.err.println("\nUnable to load the JDBC driver " + driver);
            System.err.println("Please check your CLASSPATH.");
            cnfe.printStackTrace(System.err);
        } catch (InstantiationException ie) {
            System.err.println(
                        "\nUnable to instantiate the JDBC driver " + driver);
            ie.printStackTrace(System.err);
        } catch (IllegalAccessException iae) {
            System.err.println(
                        "\nNot allowed to access the JDBC driver " + driver);
            iae.printStackTrace(System.err);
        }
    }
    public static void printSQLException(SQLException e)
    {
        // Unwraps the entire exception chain to unveil the real cause of the
        // Exception.
        while (e != null)
        {
            System.err.println("\n----- SQLException -----");
            System.err.println("  SQL State:  " + e.getSQLState());
            System.err.println("  Error Code: " + e.getErrorCode());
            System.err.println("  Message:    " + e.getMessage());
            // for stack traces, refer to derby.log or uncomment this:
            //e.printStackTrace(System.err);
            e = e.getNextException();
        }
    }
    
    private void getProperties(Properties props) {
        props.put("user", "CUST");
        props.put("password", "password");
    }
}
